﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Xml;
using System.Windows.Forms;

namespace HttpClientDemo
{
    public partial class HttpClient : Form
    {
        public HttpClient()
        {
            InitializeComponent();

            txtPin.Text = "23";
            txtValue.Text = "-1";

        }

        private void btnGet_Click(object sender, EventArgs e)
        {
            //Get user fields

            string pin = string.IsNullOrEmpty(txtPin.Text) ? "23" : txtPin.Text;
            string value = string.IsNullOrEmpty(txtValue.Text) ? "-1" : txtValue.Text;

            string xml = HttpGet(pin, value);
            BindNodes(xml);

        }

        protected void BindNodes(string xml)
        {
            //Create an XmlDoc so we can grab the nodes
            XmlDocument xDoc = new XmlDocument();
            xDoc.LoadXml(xml);

            //Bind the xml node to the form labels
            lblPin.Text = xDoc.GetElementsByTagName("pin").Item(0).InnerText;
            lblValue.Text = xDoc.GetElementsByTagName("value").Item(0).InnerText;
            lblDir.Text = xDoc.GetElementsByTagName("dir").Item(0).InnerText;

            txtXml.Text = xml;
        }

        protected string HttpGet(string pin, string value)
        {
            string url = string.Format(Properties.Settings.Default.serviceUrl, pin, value);

            Uri uri = new Uri(url);

            // Create a request
            WebRequest request = WebRequest.Create(uri);

            // Use the GET method
            request.Method = "GET";

            // Set the ContentType property of the WebRequest.
            //request.ContentType = "application/x-www-form-urlencoded";

            // Get the response.
            WebResponse response = request.GetResponse();

            // Display the return status.
            label5.Text = ((HttpWebResponse)response).StatusDescription;

            // Get the stream containing content returned by the server.
            Stream dataStream = response.GetResponseStream();

            // Open the stream using a StreamReader for easy access.
            StreamReader reader = new StreamReader(dataStream);

            // Read the content into a string.
            string responseFromServer = reader.ReadToEnd();

              // Display the content.
            //Console.WriteLine(responseFromServer);

            // Clean up the streams.
            reader.Close();
            dataStream.Close();
            response.Close();

           
            return responseFromServer;
        }
    }
}
